//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Sat May 29 19:44:01 2021 by ROOT version 6.22/06
// from TTree tree_waveform_CH1/A tree save channel CH1 wave form data and size of each measurment
// found on file: CH1_and_CH2_test.root
//////////////////////////////////////////////////////////

#ifndef single_channel_selector_h
#define single_channel_selector_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>
#include <TSelector.h>
#include <TTreeReader.h>
#include <TTreeReaderValue.h>
#include <TTreeReaderArray.h>
#include "TTree.h"

// Headers needed by this particular selector
//using std::string;
//using std::vector;
class single_channel_selector : public TSelector
{
public:
   TTreeReader fReader; //!the tree reader
   TTree *fChain = 0;   //!pointer to the analyzed TTree or TChain

   // Readers to access the data (delete the ones you do not need).
   TTreeReaderValue<Int_t> size = {fReader, "size"};
   TTreeReaderArray<Double_t> time = {fReader, "time"};
   TTreeReaderArray<Double_t> voltage = {fReader, "voltage"};

   single_channel_selector(TTree * /*tree*/ = 0) {}
   virtual ~single_channel_selector() {}
   virtual Int_t Version() const { return 2; }
   virtual void Begin(TTree *tree);
   virtual void SlaveBegin(TTree *tree);
   virtual void Init(TTree *tree);
   virtual Bool_t Notify();
   virtual Bool_t Process(Long64_t entry);
   virtual Int_t GetEntry(Long64_t entry, Int_t getall = 0) { return fChain ? fChain->GetTree()->GetEntry(entry, getall) : 0; }
   virtual void SetOption(const char *option) { fOption = option; }
   virtual void SetObject(TObject *obj) { fObject = obj; }
   virtual void SetInputList(TList *input) { fInput = input; }
   virtual TList *GetOutputList() const { return fOutput; }
   virtual void SlaveTerminate();
   virtual void Terminate();

   ClassDef(single_channel_selector, 0);

private:
   TFile *m_output_file;
   TTree *m_tree_event;

   Double_t m_baseline_voltage;
   Double_t m_max_voltage;
   Int_t m_width;
   Double_t m_charge;
   Double_t m_charge_shift;
   Int_t m_trig_charge;
   Int_t m_pass_width;
   Int_t m_trig_level;

   Double_t GetMinimumValue();
   Double_t GetCharge();
   Double_t GetBaseLineEstimate();
   Int_t GetWidth();

   Int_t Pass_trigger_charge();
   Int_t Pass_width();
   Int_t Pass_trigger_level();
};

#endif

#ifdef single_channel_selector_cxx
void single_channel_selector::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the reader is initialized.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   fReader.SetTree(tree);
}

Bool_t single_channel_selector::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

#endif // #ifdef single_channel_selector_cxx
